--- /dev/null	2019-02-24 19:19:26.000000000 +0000
+++ new/usr/src/test/elf-tests/tests/tls/x86/ld/Makefile	2019-02-24 19:19:26.300803141 +0000
@@ -0,0 +1,51 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2018, Richard Lowe.
+
+include $(SRC)/cmd/Makefile.cmd
+include $(SRC)/test/Makefile.com
+
+PROG =	x86-ld-test
+
+DATAFILES =		\
+	Makefile.test	\
+	half-ldm.s	\
+
+ROOTOPTPKG = $(ROOT)/opt/elf-tests
+TESTDIR = $(ROOTOPTPKG)/tests/tls/x86/ld
+
+CMDS = $(PROG:%=$(TESTDIR)/%)
+$(CMDS) := FILEMODE = 0555
+
+
+DATA = $(DATAFILES:%=$(TESTDIR)/%)
+$(DATA) := FILEMODE = 0444
+
+all: $(PROG)
+
+install: all $(CMDS) $(DATA)
+
+lint:
+
+clobber: clean
+	-$(RM) $(PROG)
+
+clean:
+	-$(RM) $(CLEANFILES)
+
+$(CMDS): $(TESTDIR) $(PROG)
+
+$(TESTDIR):
+	$(INS.dir)
+
+$(TESTDIR)/%: %
+	$(INS.file)
--- /dev/null	2019-02-24 19:19:26.000000000 +0000
+++ new/usr/src/test/elf-tests/tests/tls/x86/ld/Makefile.test	2019-02-24 19:19:26.494133971 +0000
@@ -0,0 +1,44 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2012, Richard Lowe.
+
+CC =		gcc
+CFLAGS =	-O1 -m32
+
+LINK.c =  $(CC) $(CFLAGS) -o $@ $^
+COMPILE.c = $(CC) $(CFLAGS) -c -o $@ $^
+COMPILE.s = $(CC) $(CFLAGS) -c -o $@ $^
+
+.KEEP_STATE:
+
+install default: all
+
+%.o: $(ELF_TESTS)/tests/tls/x86/ld/%.c
+	$(COMPILE.c)
+%.o: $(ELF_TESTS)/tests/tls/x86/ld/%.s
+	$(COMPILE.s)
+
+# an R_386_TLS_LDM with a regular R_386_PLT32 not a R_386_TLS_LDM_PLT
+PROGS +=	half-ldm
+
+half-ldm: half-ldm.o
+	$(LINK.c)
+
+all:	$(PROGS)
+
+clobber clean:
+	rm -f $(PROGS) $(STYLE1OBJS) $(STYLE1R13OBJS) $(STYLE1R12OBJS) \
+	    $(STYLE2OBJS) $(STYLE2R13OBJS) $(STYLE2R12OBJS) $(STYLE2BADNESSOBJS)
+
+fail: style2-with-badness FRC
+
+FRC:
--- /dev/null	2019-02-24 19:19:26.000000000 +0000
+++ new/usr/src/test/elf-tests/tests/tls/x86/ld/half-ldm.s	2019-02-24 19:19:26.695076835 +0000
@@ -0,0 +1,49 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.u
+ */
+
+/*
+ * Copyright 2019, Richard Lowe.
+ */
+
+        .section .rodata.str1.1,"aMS",@progbits,1
+.LC0:
+        .string "foo: %s (%p)\n"
+        .section .tdata,"awT",@progbits
+        .align 4
+	.type foo, @object
+        .size foo,4
+.local foo
+foo:
+	.string	"foo"
+        .text
+.globl main
+        .type main, @function
+main:
+        pushl %ebp
+        movl %esp, %ebp
+	/*
+         * an R_386_TLS_LDM relocation without a following
+         * followed by an R_386_PLT32 relocation, rather than an
+	 * R_386_TLS_LDM_PLT the call should be removed, and _not_
+         * left alone unrelocated as it was prior to:
+         * 10267 ld and GCC disagree about i386 local dynamic TLS
+         */
+        leal foo@TLSLDM(%ebx), %eax
+        call ___tls_get_addr@PLT
+        leal  foo@DTPOFF(%eax), %edx
+        pushl %edx
+        pushl %edx
+        pushl $.LC0
+        call printf@PLT
+        movl $0x0,%eax
+        leave
+        ret
+	.size main, .-main
--- /dev/null	2019-02-24 19:19:26.000000000 +0000
+++ new/usr/src/test/elf-tests/tests/tls/x86/ld/x86-ld-test.sh	2019-02-24 19:19:26.897725741 +0000
@@ -0,0 +1,47 @@
+#!/bin/ksh
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2012, Richard Lowe.
+
+function grep_test {
+    name=$1
+    pattern=$2
+
+    if /usr/bin/grep -q "${pattern}"; then
+	print -u2 "pass: $name"
+        else
+        print -u2 "FAIL: $name"
+        exit 1
+    fi
+}
+
+function dis_test {
+    name=${1}
+    func=${2}
+    file=${3}
+    pattern=${4}
+
+    dis -F${func} ${file} | grep_test "${name}" "${pattern}"
+}
+
+if [[ -z $ELF_TESTS ]]; then
+    print -u2 "Don't know where the test data is rooted";
+    exit 1;
+fi
+
+make -f ${ELF_TESTS}/tests/tls/x86/ld/Makefile.test
+
+dis_test "call-->nop" main half-ldm \
+    'main\+0x9:  0f 1f 44 00 00     nopl   0x0(%eax,%eax)'
+
+./half-ldm | grep_test 'half-ldm execution' \
+    '^foo: foo ([a-f0-9]*)$'
--- old/usr/src/uts/common/sys/link.h	2019-02-24 19:19:27.090579179 +0000
+++ new/usr/src/uts/common/sys/link.h	2019-02-24 19:19:27.105619267 +0000
@@ -161,6 +161,7 @@
 #define	DT_SUNW_CAPCHAINSZ	0x6000001f	/* capabilities chain size */
 /* 0x60000021 would be DT_SUNW_PARENT */
 #define	DT_SUNW_ASLR		0x60000023	/* executable ASLR desire */
+#define	DT_SUNW_KMOD		0x60000027	/* object is a kernel module */
 
 /*
  * DT_* encoding rules do not apply between DT_HIOS and DT_LOPROC
@@ -230,7 +231,7 @@
 #define	DT_VERDEF	0x6ffffffc	/* version definition table and */
 #define	DT_VERDEFNUM	0x6ffffffd	/*	associated no. of entries */
 #define	DT_VERNEED	0x6ffffffe	/* version needed table and */
-#define	DT_VERNEEDNUM	0x6fffffff	/* 	associated no. of entries */
+#define	DT_VERNEEDNUM	0x6fffffff	/*	associated no. of entries */
 
 /*
  * DT_* entries between DT_HIPROC and DT_LOPROC are reserved for processor
@@ -366,7 +367,7 @@
 	Elf32_Word	vna_next;	/* no. of bytes from start of this */
 } Elf32_Vernaux;			/*	vernaux to next vernaux entry */
 
-typedef	Elf32_Half 	Elf32_Versym;	/* Version symbol index array */
+typedef	Elf32_Half	Elf32_Versym;	/* Version symbol index array */
 
 typedef struct {
 	Elf32_Half	si_boundto;	/* direct bindings - symbol bound to */
@@ -464,7 +465,7 @@
 #define	SYMINFO_FLG_DIRECT	0x0001	/* symbol ref has direct association */
 					/*	to object containing defn. */
 #define	SYMINFO_FLG_FILTER	0x0002	/* symbol ref is associated to a */
-					/* 	standard filter */
+					/*	standard filter */
 #define	SYMINFO_FLG_PASSTHRU	SYMINFO_FLG_FILTER /* unused obsolete name */
 #define	SYMINFO_FLG_COPY	0x0004	/* symbol is a copy-reloc */
 #define	SYMINFO_FLG_LAZYLOAD	0x0008	/* object containing defn. should be */
@@ -474,7 +475,7 @@
 #define	SYMINFO_FLG_NOEXTDIRECT	0x0020	/* don't let an external reference */
 					/*	directly bind to this symbol */
 #define	SYMINFO_FLG_AUXILIARY	0x0040	/* symbol ref is associated to a */
-					/* 	auxiliary filter */
+					/*	auxiliary filter */
 #define	SYMINFO_FLG_INTERPOSE	0x0080	/* symbol defines an interposer */
 #define	SYMINFO_FLG_CAP		0x0100	/* symbol is capabilities specific */
 #define	SYMINFO_FLG_DEFERRED	0x0200	/* symbol should not be included in */
@@ -506,7 +507,7 @@
 
 struct link_map {
 	unsigned long	l_addr;		/* address at which object is mapped */
-	char 		*l_name;	/* full name of loaded object */
+	char		*l_name;	/* full name of loaded object */
 #ifdef _LP64
 	Elf64_Dyn	*l_ld;		/* dynamic structure of object */
 #else
